Import modulo.UI

'Grafik und UI initialisieren.
Graphics(800, 600)
glewInit()
UI.initialize()
SetBlend(ALPHABLEND)

'Eine Instanz unseres Controllers erzeugen und die Mthode "init" aufrufen.
Local controllerInstance:MyController = New MyController
	controllerInstance.init()

'fps beschrnkung
Local fps_60:TTimer = CreateTimer(60)

'Mainloop.
Repeat
	If MouseHit(2) controllerInstance.window.commitAnimation(controllerInstance.window.animationForKey("wobble"))
	UI.update()	
	WaitTimer(fps_60)
Flip 0 ; Cls
Until AppTerminate()


Type MyController

	'Warum die views in eine Klasse?
	'Ganz einfach: Durch das speichern der Views
	'in einer klasse knnen wir von den Methoden der klasse direkt auf die views
	'zugreifen.
	'Denn wir wollen Globale Variablen vermeiden.
	'Auerdem lsst sich die UI so gut "strukturieren", da fr jedes Fenster oder r jeden Abschnitt des programms
	'ein eigener "Controller" benutzt werden kann.
	Field window:UIWindow
	
	Field sliderR:UISlider
	Field sliderG:UISlider
	Field sliderB:UISlider
	Field labelR:UILabel
	Field labelG:UILabel
	Field labelB:UILabel
	Field colorView:MyColorView
	
	'Hier in der Methode "init" instanziieren wir unsere views
	'und setzen Attribute wie Position, Gre, Farbe, ...
	Method init()
	
		'Als allererstes erstellen wir ein Fenster.
		'Um eine Position und gre fr das Fenster fest zu legen erstellen
		'wir eine neue Instanz der Klasse "StdRect" mit den Parametern in der Reihnfolge:
		' X, Y, Width, Height.
		'So wird bei _allen_ views verfahren.
		'Diese Position is Relativ zum "Superview"/"Parent".
		'Die Zwei anderen Methoden drften sich von selbst erklren.
		'(Unterschied View und Control: Ein view kann selbst auf ereignisse, wie z.B.
		'klick und tasten reagieren, aber _keine_ "Actions" an das "Target" senden. Ein Control
		'schon. Siehe weiter unten)
		window 	= UIWindow.Create(StdRect.Create(32, 32, 200, 148))
				window.setTitle("Color")
				window.setMinSize(StdSize.Create(200, 148))
				
		sliderR	= UISlider.Create(StdRect.Create(12, 12, 120, 16))
				sliderR.setMinValue(0.0)
				sliderR.setMaxValue(255.0)
				sliderR.setValue(0.0)
				sliderR.setAlign(1, 1, 1, 0, 1, 0)
				'Wollen wir auf Aktionen des Benutzers an/auf einem View reagieren, so mssen
				'wir unseren "Controller" als target der Aktion setzen.
				'Dies geschieht mit der Methode "setTarget", die Alle Subklassen von 
				'"UIControl" besitzen, nicht aber Views, wie z.B. "UIWindow".
				'In diesem fall setzen wir _diesen_ controller als "Target" des Views.
				sliderR.setTarget(Self)
				'mit "setAction" bergeben wir unserem Control die methode die es bei einer
				'Interaktion aufrufen soll.
				'Die methode wird ber "Reflection" in dem _vorher_ gesetztem "Target" gesucht
				'und zwischengespeichert.
				'Somit ist dies kaum langsamer als ein normaler Methoden-aufruf. 
				sliderR.setAction("actionR")
				'Wollen wir das unsere "Action" durchgngig whren der Interaktion aufgerufen wird,
				'so knnen wir dies mit der Methode "setContinuously" einstellen.
				'(Default ist False)
				'Bei False wird die "Action" bei den meisten Views's nur bei einem loslassen der Linken
				'Maustaste aufgerufen.
				'Doch die Reaktion unterscheidet sich von View zu View
				'Diese "Prozedur" wiederholen wir bei allen unseren Slidern, mit den jeweiligen "Action - Methoden".
				sliderR.setContinuously(True)
				
		sliderG	= UISlider.Create(StdRect.Create(12, 36, 120, 16))
				sliderG.setMinValue(0.0)
				sliderG.setMaxValue(255.0)
				sliderG.setValue(0.0)
				sliderG.setAlign(1, 1, 1, 0, 1, 0)
				sliderG.setTarget(Self)
				sliderG.setAction("actionG")
				sliderG.setContinuously(True)
				
		sliderB	= UISlider.Create(StdRect.Create(12, 60, 120, 16))
				sliderB.setMinValue(0.0)
				sliderB.setMaxValue(255.0)
				sliderB.setValue(0.0)
				sliderB.setAlign(1, 1, 1, 0, 1, 0)
				sliderB.setTarget(Self)
				sliderB.setAction("actionB")
				sliderB.setContinuously(True)
				
		labelR	= UILabel.Create(StdRect.Create(138, 12, 50, 16))
				labelR.setTextAlign(UIAlignRight)
				labelR.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelR.setText("0")
				labelR.setAlign(0, 1, 1, 0, 0, 0)
				
		labelG	= UILabel.Create(StdRect.Create(138, 36, 50, 16))
				labelG.setTextAlign(UIAlignRight)
				labelG.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelG.setText("0")
				labelG.setAlign(0, 1, 1, 0, 0, 0)
				
		labelB	= UILabel.Create(StdRect.Create(138, 60, 50, 16))
				labelB.setTextAlign(UIAlignRight)
				labelB.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelB.setText("0")
				labelB.setAlign(0, 1, 1, 0, 0, 0)
				
		colorView	= MyColorView.Create(StdRect.Create(12, 84, 130, 32))
				colorView.setAlign(1, 1, 1, 1, 1, 1)
				colorView.r = 0
				colorView.g = 0
				colorView.b = 0
		
		'Um das Fenster und die anderen Views an zu zeigen mssen wir sie
		'einem anderen View als "Child" oder auch "Subview" hinzufgen.
		'Doch was mit dem Fenster?
		'Ein View das kein "Superview"/"Parent" haben soll wird mit der funktion "addSubview"
		'der Klasse UI dem so genannten "Nullview", einem unsichtbaren view, hinzugefgt.
		'Jedes view bitet die Methode "addSubview" mit der sich ein view hinzufgen lsst.
		'Wir fgen das Fenster dem "Nullview" an und die Slider und Labels dem Fenster.
		UI.addSubview(window)
		window.addSubview(sliderR) 
		window.addSubview(sliderG)
		window.addSubview(sliderB)
		window.addSubview(labelR)
		window.addSubview(labelG)
		window.addSubview(labelB)
		window.addSubview(colorView)
	EndMethod
	
	'-------
	'actions
	'-------
	
	'Diese "Action" wird aufgerufen wenn "sliderR"
	'bewegt wird. Als parameter bergibt sich der Slider selbst.
	'(Der parameter muss "UIView" oder eine Subklasse sein)
	Method actionR( sender:UISlider )
		'Wir nehmen uns den aktuellen Wert des Sliders und
		'setzen ihn als Text in "labelR".
		'(in diesem fall zu "int" casten, da ein "UISlider" immer
		'einen float als wert zurckgibt)
		labelR.setText(Int(sender.getValue()))
		'Hier setzen wir fr unser eigenes view auch noch den Rotateil (siehe unten).
		colorView.r = sender.getValue()
	EndMethod
	
	'Und nun das selbe fr die anderen Zwei Slider.
	'(praktischer weise knnte man auch Eine Methode
	'fr alle Drei Slider verwenden, was ich aber aus
	'"Demonstrationszwecken" nicht tue)
	Method actionG( sender:UISlider )
		labelG.setText(Int(sender.getValue()))
		colorView.g = sender.getValue()
	EndMethod
	
	Method actionB( sender:UISlider )
		labelB.setText(Int(sender.getValue()))
		colorView.b = sender.getValue()
	EndMethod

EndType


'Wir brauchen ein View um unsere eingestellte Farbe anzuzeigen!
'Doch das Modul bietet ein solchen View standardmig nicht, was nun?
'Wir erstellen eine neue Subklasse von "UIView"
'Unser view Soll ein Rechteck in einer einstellbaren Farbe darstellen.
Type MyColorView Extends UIView

	Field r:Int
	Field g:Int
	Field b:Int
	
	'Mit der Funktion "Create" soll man ein neues "MyColorView" erstellen knnen.
	'Dazu bergibt man ein Rechteck. Den Frame.
	'Wie auch bei allen anderen Views des Moduls.
	Function Create:MyColorView( frame_:StdRect )
		Local ret_:MyColorView = New MyColorView
			ret_.initWithFrame(frame_)
		Return ret_	
	EndFunction
	
	'initWithFrame? Ja, in dieser Methode wird das View initialisiert.
	'da UIView diese Methode deffiniert, sollten wir diese bei unserer Superklasse auch aufrufen
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		r = 0
		g = 0
		b = 0
	EndMethod
	
	'So, nun zum zeichnen des Views.
	'Jedes view zeichnet sich in seinem "Layer" (glMatrix).
	'Man kann daher jedes View Drehen, Skallieren, usw.
	'Doch all das passiert automatisch in UIView, so das wir nurnoch die Methode "render" berschreiben mssen.
	Method render()
		'Die Koordinaten werden so transliert, das wir bei (0;0) anfangen knnen.
		'Die absolute Breite des Views bekommen wir ber den Absoluten frame mit "getAbsoluteFrame".
		'Diese Nethode liefert ein "StdRect" zurck, welches ein Size, "StdSize" Feld enthlt.
		'Wir zeichnen also unser Rechteck in unserer Farbe ber das ganze View.
		SetColor(r, g, b)
		DrawRect(0, 0, getAbsoluteFrame().size.width, getAbsoluteFrame().size.height)
	EndMethod

EndType