SuperStrict

Import modulo.UI

Global blendfunctions:Int[] = [GL_ZERO, GL_ONE, GL_SRC_COLOR, GL_ONE_MINUS_SRC_COLOR, GL_DST_COLOR, GL_ONE_MINUS_DST_COLOR, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA, GL_DST_ALPHA, GL_ONE_MINUS_DST_ALPHA, GL_CONSTANT_COLOR, GL_ONE_MINUS_CONSTANT_COLOR, GL_CONSTANT_ALPHA,  GL_ONE_MINUS_CONSTANT_ALPHA, GL_SRC_ALPHA_SATURATE]
Global blendfunctionsString:String[] = ["GL_ZERO", "GL_ONE", "GL_SRC_COLOR", "GL_ONE_MINUS_SRC_COLOR", "GL_DST_COLOR", "GL_ONE_MINUS_DST_COLOR", "GL_SRC_ALPHA", "GL_ONE_MINUS_SRC_ALPHA", "GL_DST_ALPHA", "GL_ONE_MINUS_DST_ALPHA", "GL_CONSTANT_COLOR", "GL_ONE_MINUS_CONSTANT_COLOR", "GL_CONSTANT_ALPHA", "GL_ONE_MINUS_CONSTANT_ALPHA", "GL_SRC_ALPHA_SATURATE"]

'Grafik und UI initialisieren.
Graphics(800, 600)
glewInit()
UI.initialize()

'Eine Instanz unseres Controllers erzeugen und die Mthode "init" aufrufen.
Local controllerInstance:MyController = New MyController
	controllerInstance.init()

'fps beschrnkung
Local fps_60:TTimer = CreateTimer(60)

'Mainloop.
Repeat
	UI.update()
	WaitTimer(fps_60)
Flip 0 ; Cls
Until AppTerminate()


Type MyController

	'Warum die views in eine Klasse?
	'Ganz einfach: Durch das speichern der Views
	'in einer klasse knnen wir von den Methoden der klasse direkt auf die views
	'zugreifen.
	'Denn wir wollen Globale Variablen vermeiden.
	'Auerdem lsst sich die UI so gut "strukturieren", da fr jedes Fenster oder r jeden Abschnitt des programms
	'ein eigener "Controller" benutzt werden kann.
	Field window:UIWindow
	
	Field sliderR:UISlider
	Field sliderG:UISlider
	Field sliderB:UISlider
	Field sliderA:UISlider
	Field labelR:UILabel
	Field labelG:UILabel
	Field labelB:UILabel
	Field labelA:UILabel
	Field blendView:MyBlendView
	
	Field layerButton:UIButton
	Field bblendButton:UIButton
	Field fblendButton:UIButton
	Field alphatestButton:UIButton
	Field funcLabel:UILabel
	
	Field currentLayer:Int
	
	'Hier in der Methode "init" instanziieren wir unsere views
	'und setzen Attribute wie Position, Gre, Farbe, ...
	Method init()
	
		'Als allererstes erstellen wir ein Fenster.
		'Um eine Position und gre fr das Fenster fest zu legen erstellen
		'wir eine neue Instanz der Klasse "StdRect" mit den Parametern in der Reihnfolge:
		' X, Y, Width, Height.
		'So wird bei _allen_ views verfahren.
		'Diese Position is Relativ zum "Superview"/"Parent".
		'Die Zwei anderen Methoden drften sich von selbst erklren.
		'(Unterschied View und Control: Ein view kann selbst auf ereignisse, wie z.B.
		'klick und tasten reagieren, aber _keine_ "Actions" an das "Target" senden. Ein Control
		'schon. Siehe weiter unten)
		window 	= UIWindow.Create(StdRect.Create(32, 32, 200, 172))
				window.setTitle("Foreground")
				window.setMinSize(StdSize.Create(200, 148))
				
		sliderR	= UISlider.Create(StdRect.Create(12, 12, 120, 16))
				sliderR.setMinValue(0.0)
				sliderR.setMaxValue(255.0)
				sliderR.setValue(255.0)
				sliderR.setAlign(1, 1, 1, 0, 1, 0)
				sliderR.setTarget(Self)
				sliderR.setAction("actionR")
				sliderR.setContinuously(True)
				
		sliderG	= UISlider.Create(StdRect.Create(12, 36, 120, 16))
				sliderG.setMinValue(0.0)
				sliderG.setMaxValue(255.0)
				sliderG.setValue(255.0)
				sliderG.setAlign(1, 1, 1, 0, 1, 0)
				sliderG.setTarget(Self)
				sliderG.setAction("actionG")
				sliderG.setContinuously(True)
				
		sliderB	= UISlider.Create(StdRect.Create(12, 60, 120, 16))
				sliderB.setMinValue(0.0)
				sliderB.setMaxValue(255.0)
				sliderB.setValue(255.0)
				sliderB.setAlign(1, 1, 1, 0, 1, 0)
				sliderB.setTarget(Self)
				sliderB.setAction("actionB")
				sliderB.setContinuously(True)
				
		sliderA	= UISlider.Create(StdRect.Create(12, 84, 120, 16))
				sliderA.setMinValue(0.0)
				sliderA.setMaxValue(1.0)
				sliderA.setValue(1.0)
				sliderA.setAlign(1, 1, 1, 0, 1, 0)
				sliderA.setTarget(Self)
				sliderA.setAction("actionA")
				sliderA.setContinuously(True)
				
		labelR	= UILabel.Create(StdRect.Create(138, 12, 50, 16))
				labelR.setTextAlign(UIAlignRight)
				labelR.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelR.setText("255")
				labelR.setAlign(0, 1, 1, 0, 0, 0)
				
		labelG	= UILabel.Create(StdRect.Create(138, 36, 50, 16))
				labelG.setTextAlign(UIAlignRight)
				labelG.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelG.setText("255")
				labelG.setAlign(0, 1, 1, 0, 0, 0)
				
		labelB	= UILabel.Create(StdRect.Create(138, 60, 50, 16))
				labelB.setTextAlign(UIAlignRight)
				labelB.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelB.setText("255")
				labelB.setAlign(0, 1, 1, 0, 0, 0)
				
		labelA	= UILabel.Create(StdRect.Create(138, 84, 50, 16))
				labelA.setTextAlign(UIAlignRight)
				labelA.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				labelA.setText("1.00")
				labelA.setAlign(0, 1, 1, 0, 0, 0)
				
		layerButton = UIButton.Create(StdRect.Create(12, 108, 120/3.0, 16))
				layerButton.setTitle("Foreground")
				layerButton.setTarget(Self)
				layerButton.setAction("actionLayer")
				layerButton.setAlign(1, 1, 1, 0, 0, 0)
				
		bblendButton = UIButton.Create(StdRect.Create(120/3.0+12, 108, 120/3.0, 16))
				bblendButton.setTitle("Background Blend")
				bblendButton.setTarget(Self)
				bblendButton.setAction("actionBBlend")
				bblendButton.setAlign(1, 1, 1, 0, 0, 0)
				
		fblendButton = UIButton.Create(StdRect.Create(120/3.0*2.0+12, 108, 120/3.0, 16))
				fblendButton.setTitle("Background Blend")
				fblendButton.setTarget(Self)
				fblendButton.setAction("actionFBlend")
				fblendButton.setAlign(1, 1, 1, 0, 0, 0)
				
		alphatestButton = UIButton.Create(StdRect.Create(12+120+2, 132, 32, 16))
				alphatestButton.setOnOff(YES)
				alphatestbutton.setAlign( 0, 1, 1, 0, 0, 0  )
				alphatestButton.setState(0)
				alphatestButton.setTarget(Self)
				alphatestButton.setAction("actionAlphaTest")
				
		funcLabel	 = UILabel.Create(StdRect.Create(120 + 24, 108, 50, 16))
				funcLabel.setTextAlign(UIAlignLeft)
				funcLabel.setTextColor(VColor.Create(0.3, 0.3, 0.3, 1.0))
				funcLabel.setText("glBlendFunc(GL_ONE, GL_ZERO)")
				funcLabel.setAlign(1, 1, 1, 0, 1, 0)
				
		blendView	 = MyBlendView.Create(StdRect.Create(12, 132, 120, 8))
				blendView.setAlign(1, 1, 1, 1, 1, 1)
		
		'Um das Fenster und die anderen Views an zu zeigen mssen wir sie
		'einem anderen View als "Child" oder auch "Subview" hinzufgen.
		'Doch was mit dem Fenster?
		'Ein View das kein "Superview"/"Parent" haben soll wird mit der funktion "addSubview"
		'der Klasse UI dem so genannten "Nullview", einem unsichtbaren view, hinzugefgt.
		'Jedes view bitet die Methode "addSubview" mit der sich ein view hinzufgen lsst.
		'Wir fgen das Fenster dem "Nullview" an und die Slider und Labels dem Fenster.
		UI.addSubview(window)
		window.addSubview(sliderR)
		window.addSubview(sliderG)
		window.addSubview(sliderB)
		window.addSubview(sliderA)
		window.addSubview(labelR)
		window.addSubview(labelG)
		window.addSubview(labelB)
		window.addSubview(labelA)
		window.addSubview(layerButton)
		window.addSubview(bblendButton)
		window.addSubview(fblendButton)
		window.addSubview(alphatestButton)
		window.addSubview(funcLabel)
		window.addSubview(blendView)
		
	EndMethod
	
	'-------
	'actions
	'-------
	
	Method actionR( sender:UISlider )
		labelR.setText(Int(sender.getValue()))
		blendView.r[currentLayer] = sender.getValue()
	EndMethod
	
	Method actionG( sender:UISlider )
		labelG.setText(Int(sender.getValue()))
		blendView.g[currentLayer] = sender.getValue()
	EndMethod
	
	Method actionB( sender:UISlider )
		labelB.setText(Int(sender.getValue()))
		blendView.b[currentLayer] = sender.getValue()
	EndMethod
	
	Method actionA( sender:UISlider )
		labelA.setText(String(Float(sender.getValue()))[..4])
		blendView.a[currentLayer] = sender.getValue()
	EndMethod
	
	Method actionLayer( sender:UIButton )
		window.setTitle(["Background", "Foreground"][currentLayer])
		currentLayer = Not currentLayer
		
		sliderR.setValue(blendView.r[currentLayer])
		sliderG.setValue(blendView.g[currentLayer])
		sliderB.setValue(blendView.b[currentLayer])
		sliderA.setValue(blendView.a[currentLayer])
		labelR.setText(Int(blendView.r[currentLayer]))
		labelG.setText(Int(blendView.g[currentLayer]))
		labelB.setText(Int(blendView.b[currentLayer]))
		labelA.setText(String(Float(blendView.a[currentLayer]))[..4])
	EndMethod
	
	Method actionAlphaTest( sender:UIButton )
		blendView.alphaTest = sender.getState()
	EndMethod
	
	Method actionBBlend( sender:UIButton )
		blendView.blendFuncIndex[0] :+1
		blendView.blendFuncIndex[0]:Mod blendFunctions.length
		
		funcLabel.setText("glBlendFunc("+blendFunctionsString[blendView.blendFuncIndex[0]]+", "+blendFunctionsString[blendView.blendFuncIndex[1]]+")")
	EndMethod
	
	Method actionFBlend( sender:UIButton )
		blendView.blendFuncIndex[1] :+1
		blendView.blendFuncIndex[1]:Mod blendFunctions.length
		
		funcLabel.setText("glBlendFunc("+blendFunctionsString[blendView.blendFuncIndex[0]]+", "+blendFunctionsString[blendView.blendFuncIndex[1]]+")")
	EndMethod

EndType

Type MyBlendView Extends UIView

	Field r:Int   [2]
	Field g:Int   [2]
	Field b:Int   [2]
	Field a:Float [2]
	
	Field blendFuncIndex:Int[] = [1, 0]
	Field alphaTest:Int
	
	Field posx:Float, posy:Float, size:Float
	
	'Mit der Funktion "Create" soll man ein neues "MyColorView" erstellen knnen.
	'Dazu bergibt man ein Rechteck. Den Frame.
	'Wie auch bei allen anderen Views des Moduls.
	Function Create:MyBlendView( frame_:StdRect )
		Local ret_:MyBlendView = New MyBlendView
			ret_.initWithFrame(frame_)
		Return ret_	
	EndFunction
	
	'initWithFrame? Ja, in dieser Methode wird das View initialisiert.
	'da UIView diese Methode deffiniert, sollten wir diese bei unserer Superklasse auch aufrufen
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		r[0] = 255
		g[0] = 255
		b[0] = 255
		a[0] = 1.0
		
		r[1] = 100
		g[1] = 100
		b[1] = 100
		a[1] = 1.0
		
		size = 128.0
	EndMethod
	
	'event
	Method leftMouseDragged( event:UIEvent )
		posx :+ UIEvent.GetMouseDeltaX()
		posy :+ UIEvent.GetMouseDeltaY()
	EndMethod
	
	Method rightMouseDragged( event:UIEvent )
		size :+ (UIEvent.GetMouseDeltaX()+UIEvent.GetMouseDeltaY())/2.0
		If size < 65 size = 64
	EndMethod
	
	'So, nun zum zeichnen des Views.
	'Jedes view zeichnet sich in seinem "Layer" (glMatrix).
	'Man kann daher jedes View Drehen, Skallieren, usw.
	'Doch all das passiert automatisch in UIView, so das wir nurnoch die Methode "render" berschreiben mssen.
	Method render()
		glBlendFunc(blendFunctions[blendFuncIndex[0]], blendFunctions[blendFuncIndex[1]])
		'glBlendEquation(GL_FUNC_REVERSE_SUBTRACT)
		'glBlendFuncSeparate(GL_ONE, GL_ZERO, GL_ONE, GL_ZERO)
		If alphaTest 
			glEnable(GL_ALPHA_TEST)
		Else
			glDisable(GL_ALPHA_TEST)
		EndIf
		
		'background back
		glcolor4f(1.0, 1.0, 1.0, 1.0)
		DrawRect(0.0, 0.0, _abs_frame.size.width, _abs_frame.size.height)
		glColor4f(.5, .5, .5, 1.0)
		For Local i:Float = 0.0 To _abs_frame.size.width Step 16.0
			DrawLine(i, 0,  i,  _abs_frame.size.height)
			DrawLine(0, i,  _abs_frame.size.width, i)
		Next
		
		'enable blending
		glEnable(GL_BLEND)
		
		'background
		glColor4f(r[1]/255.0, b[1]/255.0, g[1]/255.0, a[1])
		DrawRect(12.0, 12.0, _abs_frame.size.width-24, _abs_frame.size.height-24)
		
		'foreground
		glColor4f(r[0]/255.0, b[0]/255.0, g[0]/255.0, a[0])
		DrawOval(posx, posy, size, size)
		
		glDisable(GL_BLEND)
		glEnable(GL_ALPHA_TEST)
		glBlendEquation(GL_FUNC_ADD)
	EndMethod

EndType