
Rem
bbdoc:
EndRem
Type UI Extends StdObject

	Global _instance:UI = Null			'The instance of UI
	
	'--------------
	'private fields
	'--------------
	
	Field _superview:UINullView			'The SuperView/NullView
	Field _graphics:TGraphics			'The Graphics-Object
	
	Rem
	bbdoc: Returns Default UI Instance
	End Rem
	Function GetInstance:UI()
		If Not UI._instance Then UI._instance = New UI
		Return UI._instance
	End Function
	
	Rem
	bbdoc: Updates the UI Graphics And the Message Queue.
	about: Should be called in your main loop.
	EndRem
	Function Update()
		UIEvent.update()
		UIEventManager.getInstance().update()
		'StdAnimation._update() 'Modul fehlt!
		UI.GetInstance().getNullView().updateGraphics()
	EndFunction

	'--------
	'nullview
	'--------

	Rem
	bbdoc: Returns the nullView. The Superview of all views
	EndRem
	Method getNullView:UINullView()
		Return _superview
	End Method

	Rem
	bbdoc: Add a child To the UI's Nullview
	about: Shortcut for <tt>UI.GetInstance().getNullView().addChild()</tt>
	End Rem
	Function AddSubview( view_:UIView )
		GetInstance().getNullView().addSubview(view_)
	End Function
	
	'------
	'create
	'------
	
	Rem
	bbdoc: Initialize the UI
	about: Set Graphics Driver to OpenGL, and call glewInit() first!
	EndRem
	Function Initialize( graphics_:TGraphics = Null )
		If Not graphics_ Then graphics_ = TMax2DGraphics.Current()
		UI.GetInstance().initWithGraphics( graphics_ )
	End Function
	
	Rem
	bbdoc: Init the UI with a specific Graphics Object
	EndRem
	Method initWithGraphics( graphics_:TGraphics )
			
		'Create Nullview
		Local w_:Int, h_:Int, dummy_:Int
		graphics_.GetSettings w_, h_, dummy_, dummy_, dummy_
		_graphics = graphics_
		_superview = UINullView.Create(StdRect.Create(0.0, 0.0, w_, h_))
		
		'Initialize Visuals
		Visuals.initialize()
		
		'Initialize StdAnimation
		'StdAnimation.initialize()
		
		'Initialize the event manager
		UIEventManager.Create()
		
		'initialize default style
		UIStyle.setCurrentStyle(UIDefaultStyle.Create())
		
	End Method
	
EndType