

Rem
bbdoc: UIControll is a subclass of UIView that adds action specific methods
EndRem
Type UIControl Extends UIView

	Field _target:Object
	Field _method:TMethod
	
	Field _continuously:Byte
	
	'------
	'create
	'------
	
	Function Create:UIControl( frame_:StdRect )
		Local ret_:UIControl = New UIControl
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	'------
	'action
	'------

	Rem
	bbdoc: Set the action delegate object
	EndRem
	Method setTarget( target_:Object )
		_target = target_
	EndMethod
	
	Rem
	bbdoc: Returns the set action delegate
	EndRem
	Method getTarget:Object()
		Return _target
	EndMethod
	
	Rem
	bbdoc: Set the action that will be called in the target 
	EndRem
	Method setAction( string_:String )
		If Not _target Print "no target" ; Return
		Local id_:TTypeId = TTypeId.ForObject(_target)
		_method = id_.findMethod(string_)
		If _method
			If _method.argTypes().length < 1
				UIError("to few arguments in action '"+string_+"'")
			EndIf
		Else
			UIError("unable to find method '"+string_+"'")
		EndIf
	EndMethod
	
	Rem
	bbdoc: Returns the action as TMethod
	EndRem
	Method getAction:TMethod()
		Return _method
	EndMethod
	
	Rem
	bbdoc: Calls the action if set
	EndRem
	Method callAction()
		If _target And _method
			Local args:UIView[] = [Self]
			_method.invoke(_target, [Self])
		EndIf
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Rem
	bbdoc: Set if the Control should send the Action continuously
	EndRem
	Method setContinuously( cont_:Byte )
		_continuously = cont_
	EndMethod
	
	Rem
	bbdoc: Get if the Control should send it's Action continuously
	EndRem
	Method getContinuously:Byte()
		Return _continuously
	endmethod

EndType
