
Const UILevelBackground:Int = 0
Const UILevelNormal:Int = 1
Const UILevelForeground:Int = 2

Rem
bbdoc: UINullView
about: (Final) Superview of all Views without a parent view.
End Rem
Type UINullView Extends UIView Final

	'------
	'create
	'------

	Function Create:UINullView( frame_:StdRect )
		Local nullview_:UINullView = New UINullView
			nullview_.initWithFrame(frame_)
			nullview_.setEnabled(NO)
		Return nullview_
	End Function
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		_abs_frame = getFrame()
		_visible_frame = getFrame()
	EndMethod
	
	'
	'
	'
	
	Method getParent:UIView()
		Return Null
	EndMethod
	
	Method receiveEvents:Int()
		Return NO
	EndMethod
	
	Method updateAbsoluteFrame()
	EndMethod
	
	Method updateAlignment()
		Return
	EndMethod
	
	Method collidesWithPoint:Int( point_:StdPoint )
		Return NO
	EndMethod
	
	Method updateGraphics()
			Local childlink_:TLink = _subviews.FirstLink()
			
			While childlink_
				Local child_:UIView = UIView(childlink_.Value())
				
				If child_ child_.updateGraphics()
				childlink_ = childlink_.NextLink()
			Wend
	End Method
	
	Method setClip( clip_:Int )
		Return
	End Method
	
	Method getClip:Int()
		Return NO
	End Method
	
	Method dispatchEvent(event_:UIEvent)
		Return 
	EndMethod
	
End Type