
Rem
bbdoc: Class that provides all event action method
about: (Abstract)
EndRem
Type UIResponder Extends StdDObject Abstract

	Global _firstResponder:UIResponder
	
	Field _nextResponder:UIResponder
	
	'---------------
	'first responder
	'---------------
	
	Rem
	bbdoc: Returns the first responder for events 
	EndRem
	Function firstResponder:UIResponder()
		Return _firstResponder
	EndFunction
	
	'------------------------
	'changing first responder
	'------------------------
	
	Rem
	bbdoc: Returns if the responder can become firstResponder
	EndRem
	Method acceptsFirstResponder:Int()
		Return YES
	EndMethod

	Rem
	bbdoc: Returns if the responder would give up its firstRespoinder state
	EndRem
	Method resignFirstResponder:Int()
		Return YES
	EndMethod

	Rem
	bbdoc: Set the responder as firstResponder.<br>See #acceptsFirstResponder and #resignFirstResponder for more information
	EndRem
	Method becomeFirstResponder:Int()
		If UIResponder.firstResponder()
			If Self.acceptsFirstResponder() And UIResponder.firstResponder().resignFirstResponder()
				UIResponder._firstResponder = Self
				Return YES
			Else
				Return NO
			EndIf
		Else
			If Self.acceptsFirstResponder()
				UIResponder._firstResponder = Self
				Return YES
			Else
				Return NO
			EndIf
		EndIf
	EndMethod
	
	'--------------
	'next responder
	'--------------

	Method setNextResponder( responder_:UIResponder )
		If Not responder_ Return
		_nextResponder = responder_
	EndMethod

	Method getNextResponder:UIResponder()
		Return _nextResponder
	EndMethod

	'------
	'events
	'------
	
	Method respondToMouseEvents:Int()
		Return yes
	EndMethod
	
	Method respondToKeyEvents:Int()
		Return yes
	EndMethod
	
	'------------
	'mouse events
	'------------
	
	Method leftMouseDown( event_:UIEvent )
	EndMethod
	
	Method leftMouseUp( event_:UIEvent )
	EndMethod
	
	Method leftMouseDragged( event_:UIEvent )
	EndMethod
	
	Method rightMouseDown( event_:UIEvent )
	EndMethod
	
	Method rightMouseUp( event_:UIEvent )
	EndMethod
	
	Method rightMouseDragged( event_:UIEvent )
	EndMethod
	
	Method mouseMoved( event_:UIEvent )
	EndMethod
		
	Method mouseEntered( event_:UIEvent )
	EndMethod

	Method mouseLeft( event_:UIEvent )
	EndMethod
	
	Method mouseWheel( event_:UIEvent )
	EndMethod
	
	'----------
	'key events
	'----------
	
	Method keyPressed( event_:UIEvent )
	EndMethod
	
	Method keyUp( event_:UIEvent )
	EndMethod
	
	Method character( event_:UIEvent )
	EndMethod
	
	'--------
	'dispatch
	'--------
	
	Method dispatchEvent( event_:UIEvent )
		If respondToMouseEvents()
			Select(event_.getType())
				'left mouse
				Case UIEventLeftMouseDown	
					leftMouseDown(event_)
				Case UIEventLeftMouseUp
					leftMouseUp(event_)
				Case UIEventLeftMouseDragged
					leftMouseDragged(event_)
				'right mouse
				Case UIEventRightMouseDown	
					rightMouseDown(event_)
				Case UIEventRightMouseUp
					rightMouseUp(event_)
				Case UIEventRightMouseDragged
					rightMouseDragged(event_)
				'mouse
				Case UIEventMouseMoved
					mouseMoved(event_)
				Case UIEventMouseEntered
					mouseEntered(event_)
				Case UIEventMouseleft
					mouseLeft(event_)
				Case UIEventMouseWheel
					mouseWheel(event_)
			EndSelect
		ElseIf event_.getType() <> UIEventKeyDown And event_.getType() <> UIEventKeyUp
			getNextResponder().dispatchEvent(event_)
		EndIf
		
		If respondToKeyEvents()
			Select(event_.getType())
				Case UIEventKeyDown
					keyPressed(event_)
				Case UIEventKeyUp
					keyUp(event_)
				Case UIEventCharacter
					character(event_)
			EndSelect
		ElseIf event_.getType() = UIEventKeyDown Or event_.getType() = UIEventKeyUp
			getNextResponder().dispatchEvent(event_)
		EndIf
	EndMethod
	
EndType
