
Rem
bbdoc: state ON
EndRem
Const UIButtonStateOn	:Int = 1

Rem
bbdoc: state OFF
EndRem
Const UIButtonStateOff	:Int = 0

Rem
bbdoc:
EndRem
Type UIButtonResource

	Global _instance:UIButtonResource

	Field _gradient:VLinearGradient[4]
	Field _fontcolor:VColor
	
	'-----------
	'getInstance
	'-----------
	
	Function getInstance:UIButtonResource()
		If Not UIButtonResource._instance UIButtonResource._instance = UIButtonResource.Create()
		Return UIButtonResource._instance 
	EndFunction
	
	'------
	'create
	'------
	
	Function Create:UIButtonResource()
		Local ret_:UIButtonResource = New UIButtonResource
			ret_.init()
		Return ret_
	EndFunction
	
	Method init()
		_fontcolor = VColor.Create(0.3, 0.3, 0.3, 1.0)
		_gradient[0] = VLinearGradient.Create()
			_gradient[0].addColorStop(0.0, 0.8, 0.8, 0.8, 1.0)
			_gradient[0].addColorStop(1.0, 0.6, 0.6, 0.6, 1.0)
			_gradient[0].setOrientation(1)
		_gradient[1] = VLinearGradient.Create()
			_gradient[1].addColorStop(0.0, 0.8, 0.8, 0.8, 1.0)
			_gradient[1].addColorStop(1.0, 0.6, 0.6, 0.6, 1.0)
			_gradient[1].setOrientation(1)
		_gradient[2] = VLinearGradient.Create()
			_gradient[2].addColorStop(0.0, 0.6, 0.6, 0.6, 1.0)
			_gradient[2].addColorStop(1.0, 0.4, 0.4, 0.4, 1.0)
			_gradient[2].setOrientation(1)
	EndMethod
EndType

Rem
bbdoc: UIButton
EndRem
Type UIButton Extends UIControl

	Field _title:String

	Field _onoff:Byte
	Field _state:Byte

	Field _hover:Byte
	
	'------
	'create
	'------
	
	Function Create:UIButton( frame_:StdRect )
		Local ret_:UIButton = New UIButton
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		setTitle("")
		setOnOff(NO)
		setState(UIButtonStateOff)
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Method setTitle( title_:String )
		_title = title_
	EndMethod
	
	Method getTitle:String()
		Return _title
	EndMethod
	
	Method setOnOff( onoff_:Byte )
		_onoff = onoff_
	EndMethod
	
	Method getOnOff:Byte()
		Return _onoff
	EndMethod
	
	Method setState( state_:Byte )
		_state = state_
	EndMethod
	
	Method getState:Byte()
		Return _state
	EndMethod

	'------
	'events
	'------
	
	Method mouseEntered( event:UIEvent )
		_hover = 1
	EndMethod
	
	Method mouseLeft( event:UIEvent )
		_hover = 0
	EndMethod
	
	Method leftMouseDown( event:UIEvent )
		_hover = 2
	EndMethod
	
	Method leftMouseUp( event:UIEvent )
		_hover = 1
				
		callAction()
		If getOnOff() setState(1-getState())
	EndMethod
	
	'------
	'render
	'------
	
	Method render()
		UIButtonResource.getInstance()._gradient[Min(_hover, 2)].drawInRect(0.0, 0.0, _abs_frame.size.width, _abs_frame.size.height)
		UIButtonResource.getInstance()._fontcolor.set()
		DrawText("test", _abs_frame.size.width/2.0-TextWidth("test")/2.0, _abs_frame.size.height/2.0-TextHeight("test")/2.0)
	EndMethod
EndType