
Rem
bbdoc: Text Align Left
EndRem
Const UIAlignLeft  :Byte = %100
Const UIAlignTop   :Byte = %100

Rem
bbdoc: Text Align Right
EndRem
Const UIAlignRight  :Byte = %001
Const UIAlignBottom :Byte = %001

Rem
bbdoc: Text Align Center
EndRem
Const UIAlignCenter:Byte = %010

Rem
bbdoc: UILabel
EndRem
Type UILabel Extends UIView

	Field _text:String
	Field _text_align:Byte, _text_valign:Byte
	Field _text_color:VColor
	
	Field _text_width :Float
	Field _text_height:Float
	
	'------
	'create
	'------
	
	Function Create:UILabel( frame_:StdRect )
		Local ret_:UILabel = New UILabel
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		setText("")
		setTextAlign(UIAlignLeft)
		setTextColor(VColor.black())
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Rem
	bbdoc: Set the text
	EndRem
	Method setText( text_:String )
		_text = text_
		_text_width  = TextWidth(text_)
		_text_height = TextHeight(text_)
	EndMethod
	
	Rem
	bbdoc: Get the text
	EndRem
	Method getText:String()
		Return _text
	EndMethod
	
	Rem
	bbdoc: Set the text alignment
	about: 
	[
	UIAlignLeft
	UIAlignRight
	UIAlignCenter
	]
	EndRem
	Method setTextAlign( align_:Byte=UIAlignLeft )
		_text_align = align_
	EndMethod
	
	Rem
	bbdoc: Get the teyt alignment
	EndRem
	Method getTextAlign:Byte()
		Return _text_align
	EndMethod
	
	Rem
	bbdoc: Set the text alignment
	about: 
	[
	UIAlignLeft
	UIAlignRight
	UIAlignCenter
	]
	EndRem
	Method setTextVerticalAlign( align_:Byte=UIAlignLeft )
		_text_valign = align_
	EndMethod
	
	Rem
	bbdoc: Get the teyt alignment
	EndRem
	Method getTextVerticalAlign:Byte()
		Return _text_valign
	EndMethod
	
	Rem
	bbdoc: Set the text color (default is black)
	EndRem
	Method setTextColor( color_:VColor )
		_text_color = color_
	EndMethod
	
	Rem
	bbdoc: Get the text color
	EndRem
	Method getTextColor:VColor()
		Return _text_color
	EndMethod
	
	'place in fields later!
	Method getContentWidth:Float()
		Return TextWidth(getText())
	EndMethod
	
	Method getContentHeight:Float()
		Return TextWidth(getText())
	EndMethod
	
	'------
	'render
	'------
	
	Method render()
		UIStyle.getCurrentStyle().renderLabel(Self)
	EndMethod
	
	'-----
	'event
	'-----
	
	Method respondToMouseEvents:Int()
		Return NO
	EndMethod
	
	Method respondToKeyEvents:Int()
		Return NO
	EndMethod

EndType
