
Rem
bbdoc: UIProgressBar
EndRem
Type UIProgressBar Extends UIView
	Field _min:Float
	Field _max:Float
	Field _value:Float
	
	Field _pos:Float
	
	Field _orientation:Int
	
	'------
	'create
	'------
	
	Function Create:UIProgressBar( frame_:StdRect )
		Local ret_:UIProgressBar = New UIProgressBar
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		setMinValue(0.0)
		setMaxValue(100.0)
		setValue(50.0)
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Rem
	bbdoc: Set the sliders minimal value
	EndRem
	Method setMinValue( min_:Float )
		_min = min_
	EndMethod
	
	Rem
	bbdoc: Get the sliders minimal value
	EndRem
	Method getMinValue:Float()
		Return _min
	EndMethod
	
	Rem
	bbdoc: Set the sliders maximum value
	EndRem
	Method setMaxValue( max_:Float )
		_max = max_
	EndMethod
	
	Rem
	bbdoc: Get the sliders maximum value
	EndRem
	Method getMaxValue:Float()
		Return _max
	EndMethod
	
	Rem
	bbdoc: Set the sliders current value
	EndRem
	Method setValue( value_:Float )
		_value = value_
		If _value > _max _value = _max
		If _value < _min _value = _min
	EndMethod
	
	Rem
	bbdoc: Get the sliders current Value
	EndRem
	Method getValue:Float()
		Return _value
	EndMethod
	
	Rem
	bbdoc: Set the sliders Orientation: 
	[
	UIOrientationHorizontal
	UIOrientationVertical
	]
	EndRem
	Method setOrientation( orientation_:Byte )
		_orientation = orientation_
	EndMethod
	
	Rem
	bbdoc: Get the sliders Orientation. See #setOrientation for more information
	EndRem
	Method getOrientation:Byte()
		Return _orientation
	EndMethod

	'------
	'events
	'------

	'------
	'render
	'------
	
	Method render()
	'	Self._style.renderSlider(Self)
		calcKnobPos()
		VColor.black().set()
		DrawRect(0, 0, _abs_frame.size.width, _abs_frame.size.height)
		VColor.white().set()
		DrawRect(0, 0, _pos, _abs_frame.size.height)
	EndMethod
	
	'-------
	'private
	'-------
	
	Method calcKnobPos()
		Local vdelta_:Float = Max(_min, _max) - Min(_min, _max)
		Local pdelta_:Float = _abs_frame.size.width
		
		_pos = pdelta_/vdelta_*_value
	EndMethod
	
EndType
