
Rem
bbdoc: UIStepper
EndRem
Type UIStepper Extends UIView

	Field _buttonup:UIButton
	Field _buttondown:UIButton
	
	Field _step:Float
	Field _value:Float
	Field _min:Float
	Field _max:Float
	
	Field _orientation:Int
	
	'------
	'create
	'------
	
	Function Create:UIStepper( frame_:StdRect )
		Local ret_:UIStepper = New UIStepper
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		setMinValue(0.0)
		setMaxValue(100.0)
		setValue(50.0)
		setStep(1.0)
		
		
		_buttonup = UIButton.Create(StdRect.Create(0.0, 0.0, 0.0, 0.0))
		_buttondown = UIButton.Create(StdRect.Create(0.0, 0.0, 0.0, 0.0))
		_buttonup.setTarget(Self)
		_buttonup.setAction("pushUp")
		_buttondown.setTarget(Self)
		_buttondown.setAction("pushDown")
		Self.addSubView(_buttonup)
		Self.addSubView(_buttondown)
		
		setOrientation(1)
	EndMethod
	
	'-----
	'frame
	'-----
	
	Method setButtonFrame( frame_:StdRect )
		Select( _orientation )
			Case UIOrientationVertical
				Local button_height_:Float = frame_.size.height/2.0
				
				_buttonup.setFrame(StdRect.Create(0.0, 0.0, button_height_, button_height_))
				_buttondown.setFrame(StdRect.Create(0.0, button_height_, button_height_, button_height_))
			Case UIOrientationHorizontal
				Local button_width_:Float = frame_.size.width/2.0
				
				_buttonup.setFrame(StdRect.Create(button_width_, 0.0, button_width_, button_width_))
				_buttondown.setFrame(StdRect.Create(0.0, 0.0, button_width_, button_width_))
		EndSelect
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Rem
	bbdoc: Set the sliders minimal value
	EndRem
	Method setMinValue( min_:Float )
		_min = min_
	EndMethod
	
	Rem
	bbdoc: Get the sliders minimal value
	EndRem
	Method getMinValue:Float()
		Return _min
	EndMethod
	
	Rem
	bbdoc: Set the sliders maximum value
	EndRem
	Method setMaxValue( max_:Float )
		_max = max_
	EndMethod
	
	Rem
	bbdoc: Get the sliders maximum value
	EndRem
	Method getMaxValue:Float()
		Return _max
	EndMethod
	
	Rem
	bbdoc: Set the sliders current value
	EndRem
	Method setValue( value_:Float )
		_value = value_
	EndMethod
	
	Rem
	bbdoc: Get the sliders current Value
	EndRem
	Method getValue:Float()
		Return _value
	EndMethod
	
	Rem
	bbdoc: Set the step, the value should increased/decreased with
	about: Default is 1.0
	EndRem
	Method setStep( Step_:Float )
		_step = step_
	EndMethod
	
	Rem
	bbdoc: Get the step
	EndRem
	Method getStep:Float()
		Return _step
	EndMethod
	
	Rem
	bbdoc: Set the sliders Orientation: 
	[
	UIOrientationHorizontal
	UIOrientationVertical
	]
	EndRem
	Method setOrientation( orientation_:Byte )
		_orientation = orientation_
		setButtonFrame(_frame)
	EndMethod
	
	Rem
	bbdoc: Get the sliders Orientation. See #setOrientation for more information
	EndRem
	Method getOrientation:Byte()
		Return _orientation
	EndMethod
	
	'------
	'render
	'------
	
	Method render()
		
	EndMethod
	
	'-----
	'event
	'-----
	
	Method respondToMouseEvents:Int()
		Return Yes
	EndMethod
	
	Method respondToKeyEvents:Int()
		Return NO
	EndMethod
	
	'-------
	'private
	'-------

	Method pushUp( button:UIButton )
		_value :+ _step
		If _value > _max _value = _max
	EndMethod

	Method pushDown( button:UIButton )
		_value :- _step
		If _value < _min _value = _min
	EndMethod

EndType

